org.objectweb.asm.commons

## Class StaticInitMerger

- java.lang.Object
- - org.objectweb.asm.ClassVisitor
  - - org.objectweb.asm.commons.StaticInitMerger

-     public class StaticInitMerger
      extends ClassVisitor

  A `ClassVisitor` that merges clinit methods into a single one.
  Author:
    Eric Bruneton

- - ### Field Summary

    - ### Fields inherited from class org.objectweb.asm.ClassVisitor

      `api, cv`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `StaticInitMerger(int api, String prefix, ClassVisitor cv)`
    `` | `StaticInitMerger(String prefix, ClassVisitor cv)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `visit(int version, int access, String name, String signature, String superName, String[] interfaces)` Visits the header of the class.
    `void` | `visitEnd()` Visits the end of the class.
    `MethodVisitor` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)` Visits a method of the class.

    - ### Methods inherited from class org.objectweb.asm.ClassVisitor

      `visitAnnotation, visitAttribute, visitField, visitInnerClass, visitOuterClass, visitSource, visitTypeAnnotation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### StaticInitMerger

          public StaticInitMerger(String prefix,
                                  ClassVisitor cv)

    - #### StaticInitMerger

          protected StaticInitMerger(int api,
                                     String prefix,
                                     ClassVisitor cv)

  - ### Method Detail

    - #### visit

          public void visit(int version,
                            int access,
                            String name,
                            String signature,
                            String superName,
                            String[] interfaces)

      Description copied from class: `ClassVisitor`
      Visits the header of the class.
      Overrides:
        `visit` in class `ClassVisitor`
      Parameters:
        `version` - the class version.
        `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated.
        `name` - the internal name of the class (see `getInternalName`).
        `signature` - the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.
        `superName` - the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.
        `interfaces` - the internal names of the class's interfaces (see `getInternalName`). May be `null`.

    - #### visitMethod

          public MethodVisitor visitMethod(int access,
                                           String name,
                                           String desc,
                                           String signature,
                                           String[] exceptions)

      Description copied from class: `ClassVisitor`
      Visits a method of the class. This method must return a new `MethodVisitor` instance (or `null`) each time it is called, i.e., it should not return a previously returned visitor.
      Overrides:
        `visitMethod` in class `ClassVisitor`
      Parameters:
        `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `signature` - the method's signature. May be `null` if the method parameters, return type and exceptions do not use generic types.
        `exceptions` - the internal names of the method's exception classes (see `getInternalName`). May be `null`.
      Returns:
        an object to visit the byte code of the method, or `null` if this class visitor is not interested in visiting the code of this method.

    - #### visitEnd

          public void visitEnd()

      Description copied from class: `ClassVisitor`
      Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.
      Overrides:
        `visitEnd` in class `ClassVisitor`